Name:           oracle-php-release-el6
Version:        1.0
Release:        2%{dist}
Summary:        PHP yum repository configuration

Group:          System Environment
License:        GPLv2

Source0:        oracle-php-ol6.repo
Source1:        LICENSE

BuildArch:     x86_64
Requires:      oraclelinux-release-el6
Requires:      grep
Requires:      sed
Requires:      yum-utils
Requires:      curl

%description
This package contains the  PHP yum repository configuration.

%prep
%setup  -q  -c -T


%build


%install
rm -rf $RPM_BUILD_ROOT


# yum
install -m 755 -d $RPM_BUILD_ROOT/usr/share/doc/%{name}/
install -dm 755 $RPM_BUILD_ROOT%{_sysconfdir}/yum.repos.d
install -pm 644 %{SOURCE0}   \
    $RPM_BUILD_ROOT%{_sysconfdir}/yum.repos.d
install -m 755 %{SOURCE1}  $RPM_BUILD_ROOT%{_datadir}/doc/%{name}

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%dir %{_datadir}/doc/%{name}
%{_datadir}/doc/%{name}/*
%config(noreplace) /etc/yum.repos.d/*


%pre
if [ -f /etc/yum.repos.d/public-yum-ol6.repo ];then
   enabled_repos=$(yum-config-manager | grep ol6 | grep "^\[" | egrep -v -e "x86_64|i386" | sed -e "s|\[||" | sed -e "s|\]||")
   echo $enabled_repos > /etc/yum.repos.d/.oracle_enable_repolist
   touch /etc/yum.repos.d/.public-yum-ol6.repo.moved

   mv /etc/yum.repos.d/public-yum-ol6.repo /etc/yum.repos.d/public-yum-ol6.repo.`date +%Y%m%d`
   if [ ! -f /etc/yum.repos.d/.ol_yum_configure ]; then 
     echo "" 
RED='\033[0;31m'
 NC='\033[0m' # No Color
 bold=$(tput bold)
 normal=$(tput sgr0)

echo -e "${RED}${bold}IMPORTANT: A legacy Oracle Linux yum server repo file was found.${normal}${NC} Oracle Linux yum server repository configurations have changed which means public-yum-ol6.repo will no longer be updated. New repository configuration files have been installed but are disabled. ${RED}${bold}To complete the transition, run this script as the root user:${normal}${NC}"
echo
echo -e "${RED}${bold}/usr/bin/ol_yum_configure.sh${normal}${NC}"
echo
echo "See https://yum.oracle.com/faq.html for more information."

     echo "   "
   fi
fi

%post
if [ ! -f /etc/yum/vars/ociregion ]; then
(http_proxy="";curl --max-time 1 -q -f http://169.254.169.254/opc/v1/instance/ > /dev/null 2>&1)
if [ $? != 0 ]; then
  echo > /etc/yum/vars/ociregion
else
 instance_region=$(http_proxy="";curl http://169.254.169.254/opc/v1/instance/ -s | jq -r '.region' | cut -d '-' -f 2)
  if [ -z "$instance_region" ]; then
    echo > /etc/yum/vars/ociregion
  else
    echo "-$instance_region" > /etc/yum/vars/ociregion
  fi
 fi
fi
(http_proxy="";curl --max-time 1 -q -f http://169.254.169.254/opc/v1/instance/ > /dev/null 2>&1)
if [ $? = 0 ]; then
 sed -i "s|https:|http:|" /etc/yum.repos.d/oracle-php-ol6.repo
fi
if [ -f /etc/yum.repos.d/.public-yum-ol6.repo.moved ] && [ -f /etc/yum.repos.d/.oracle_enable_repolist  ]; then
    enabled_repos=`cat /etc/yum.repos.d/.oracle_enable_repolist`
    repofound=0
    for i in `grep "^\[" /etc/yum.repos.d/oracle-php-ol6.repo | sed -e "s|\[||" | sed -e "s|\]||"`; do
       if echo $enabled_repos | egrep -we "$i|public_$i"  > /dev/null; then
        repofound=1
       fi
    done
    if [ $repofound = 0 ]; then
     mv /etc/yum.repos.d/oracle-php-ol6.repo /etc/yum.repos.d/oracle-php-ol6.repo.incomplete
    else
    for i in `grep "^\[" /etc/yum.repos.d/oracle-php-ol6.repo | sed -e "s|\[||" | sed -e "s|\]||"`; do
       if echo $enabled_repos | egrep -we "$i|public_$i"  > /dev/null; then
         yum-config-manager --enable $i > /dev/null
         sed -i -e "{s/$i //
                  s/$i$//
                  s/public_$i$//
                  s/public_$i //}" /etc/yum.repos.d/.oracle_enable_repolist
       else
         if [ $repofound -eq 1 ]; then
           yum-config-manager --disable $i > /dev/null
         fi
       fi
    done
   fi
fi


if [ -e /etc/sysconfig/rhn/systemid ];then
  if [ -f /etc/yum.repos.d/oracle-php-ol6.repo.incomplete ]; then
    sed -i 's/enabled=1/enabled=0/' /etc/yum.repos.d/oracle-php-ol6.repo.incomplete
  else
    sed -i 's/enabled=1/enabled=0/' /etc/yum.repos.d/oracle-php-ol6.repo
  fi
fi

if [ -f /etc/yum.repos.d/.public-yum-ol6.repo.moved ] && [ -f /etc/yum.repos.d/oracle-php-ol6.repo ]; then
  mv /etc/yum.repos.d/oracle-php-ol6.repo /etc/yum.repos.d/oracle-php-ol6.repo.disabled
fi

%posttrans
if [ -f /etc/yum.repos.d/.public-yum-ol6.repo.moved ]; then
   mv /etc/yum.repos.d/public-yum-ol6.repo.`date +%Y%m%d` /etc/yum.repos.d/public-yum-ol6.repo
   rm -f /etc/yum.repos.d/.public-yum-ol6.repo.moved
fi




%changelog
* Wed Jan 23 2019 Keshav Sharma <keshav.sharma@oracle.com> 1.0-2
- Enhance logic to detect oci instance [ OraBug 29241080]
- Do not overwrite /etc/yun/vars/ociregion file.

* Tue Aug 28 2018 Tony Lam <tony.l.lam@oracle.com> 1.0-1
- Initial package

